package model;
import java.awt.Cursor;
import java.util.Vector;

import javax.swing.AbstractListModel;
import javax.swing.JPanel;

import demo.list.ListDemo;

public class GeneratedListModel extends AbstractListModel {
	ListDemo demo;
	Permuter permuter;

	public Vector prefix = new Vector();
	public Vector suffix = new Vector();

	public GeneratedListModel(ListDemo demo) {
		this.demo = demo;
	}

	private void update() {
		permuter = new Permuter(getSize());
		fireContentsChanged(this, 0, getSize());
	}

	public void addPrefix(String s) {
		if (!prefix.contains(s)) {
			
			// Special Case for "Pacific"
			if ("Pacific".equals(s)) {
				// Busy Operation Simulation
				for (int i = 0; i < 400000000; i++) {
					System.currentTimeMillis();
				}
			}
			
			prefix.addElement(s);
			update();
		}
	}

	public void removePrefix(String s) {
		prefix.removeElement(s);
		update();
	}

	public void addSuffix(String s) {
		if (!suffix.contains(s)) {
			suffix.addElement(s);
			update();
		}
	}

	public void removeSuffix(String s) {
		suffix.removeElement(s);
		update();
	}

	public int getSize() {
		return prefix.size() * suffix.size();
	}

	public Object getElementAt(int index) {
		if (permuter == null) {
			update();
		}
		// morph the index to another int -- this has the benefit of
		// causing the list to look random.
		int j = permuter.map(index);
		int ps = prefix.size();
		int ss = suffix.size();
		return (String) prefix.elementAt(j % ps) + (String) suffix.elementAt((j / ps) % ss);
	}
}
